Index: pplinux/linuxnew/drivers/i2c/i2c-asics.c
diff -u /dev/null pplinux/linuxnew/drivers/i2c/i2c-asics.c:1.8
--- /dev/null	Tue May 24 10:37:58 2005
+++ pplinux/linuxnew/drivers/i2c/i2c-asics.c	Thu May 19 15:14:39 2005
@@ -0,0 +1,716 @@
+/*  /drivers/i2c/busses/i2c-asics.c
+	Support of the Asics i2c bus
+	
+	Copyright (C) 2004 Microtronix Datacom Ltd.
+	
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+   
+    Written by Wentao Xu <wentao@microtronix.com>
+*/
+
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/ioport.h>
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/delay.h>
+#include <linux/slab.h>
+#include <linux/init.h>
+#include <linux/interrupt.h>
+#include <linux/wait.h>
+#include <linux/pci.h>
+#include <linux/i2c.h>
+#include <linux/i2c-slave.h>
+#include <linux/i2c-algo-asics.h>
+#include <asm/io.h>
+#include <asm/irq.h>
+#include "i2c-asics.h"
+
+MODULE_AUTHOR("Peppercon AG");
+MODULE_DESCRIPTION("I2C-Bus adapter routines for Asics i2c controller");
+MODULE_LICENSE("GPL");
+
+#define ASICSI2C_IO_SIZE 	32
+#define ASICSI2C_CLOCK_DEFAULT	66  /* MHz */
+#define ASICSI2C_SCL_DEFAULT	100 /* kHz */
+#define ASICSI2C_IRQ_NO_INTMUX	-1
+
+#if defined(LARA_KIMMSI) || defined (LARA_KIMAMD)
+# define ASICS_USE_PCI
+# define ASICS_USE_INTMUX
+# define ASICS_PCI_VENDOR_ID	0x1743	
+# define ASICS_PCI_DEVICE_ID	0x1003
+# define ASICS_PCI_BAR_NO	1
+# define INTMUX_OFFSET		0x9A0000
+# define INTMUX_SIZE		4
+#else
+# define ASICS_BASE		0x81000000
+#endif
+
+#define ASICS_I2C_IRQ		27 /* common irq for all cores */
+
+#define I2C_0_BASE_OFFSET	0x900000
+#define I2C_0_INTMUX		1
+
+#define I2C_1_BASE_OFFSET	0x910000
+#define I2C_1_INTMUX		2
+
+#define I2C_2_BASE_OFFSET	0x920000
+#define I2C_2_INTMUX		3
+
+#define I2C_3_BASE_OFFSET	0x930000
+#define I2C_3_INTMUX		4
+
+#define I2C_4_BASE_OFFSET	0x940000
+#define I2C_4_INTMUX		5
+
+#define I2C_DDC_BASE_OFFSET	0x9C0000
+#define I2C_DDC_INTMUX		15
+
+#define I2C_LAN_BASE_OFFSET	0x9D0000
+#define I2C_LAN_INTMUX		16
+
+/******************************************************************************
+* debugging                                                                   *
+******************************************************************************/
+
+/*
+  DBG_LEVEL == 0 --> no debugging
+  DBG_LEVEL < 0  --> short debugging
+  DBG_LEVEL > 0  --> full debugging
+*/
+
+#define DBG_LEVEL 0
+
+#if DBG_LEVEL > 0
+#  define DBG(fmt, x...)	printk(/*KERN_DEBUG*/KERN_INFO "i2c-asics: " fmt, ##x)
+#else
+#  define DBG(fmt, x...)	((void)0)
+#endif
+#if DBG_LEVEL > 1
+#  define DBG2(fmt, x...) 	DBG( fmt, ##x )
+#else
+#  define DBG2(fmt, x...) 	((void)0)
+#endif
+#if DBG_LEVEL > 2
+#  define DBG3(fmt, x...) 	DBG( fmt, ##x )
+#else
+#  define DBG3(fmt, x...) 	((void)0)
+#endif
+
+#if DBG_LEVEL < 0
+#  define SDBG(fmt, x...) 	printk(/*KERN_DEBUG*/KERN_INFO fmt, ##x)
+#else
+#  define SDBG(fmt, x...) 	((void)0)
+#endif
+
+#define INFO(fmt, x...)		printk(KERN_INFO    "i2c-asics: " fmt, ##x)
+#define WARN(fmt, x...)		printk(KERN_WARNING "i2c-asics: " fmt, ##x)
+#define CRIT(fmt, x...)		printk(KERN_CRIT    "i2c-asics: " fmt, ##x)
+#define ERR(fmt, x...)		printk(KERN_ERR     "i2c-asics: " fmt, ##x)
+
+#define DBG_SEND_MESSAGES_ON_LOAD	0
+
+#if DBG_SEND_MESSAGES_ON_LOAD
+#include "i2c-asics-debug.c"
+#endif
+
+/******************************************************************************
+ * debugging via debug pin                                                    *
+ ******************************************************************************/
+
+#define noGPIO_DEBUG
+
+#ifdef GPIO_DEBUG
+
+#define PPC405_GPIO_REGS_ADDR		((u32)0xEF600700)
+#define PPC405_GPIO_REGS_SIZE		((size_t)0x20)
+
+static volatile u32 * gpio_regs = NULL;
+
+static void
+gpio_init(void) {
+	gpio_regs = ioremap_nocache(PPC405_GPIO_REGS_ADDR,
+				    PPC405_GPIO_REGS_SIZE);
+	
+	if (gpio_regs) {
+		INFO("GPIO debugging enabled.\n");
+	} else {
+		WARN("Could not map GPIO registers!\n");
+	}
+}
+
+static void
+gpio_cleanup(void) {
+	if (gpio_regs) {
+		iounmap((void *)gpio_regs);
+		INFO("GPIO debugging disabled.\n");
+	} else {
+		INFO("Could not unmap GPIO registers, not mapped.\n");
+	}
+}
+
+static void
+gpio_bit_set(unsigned int value)
+{
+	if (gpio_regs) {
+		int bitnum = 31 - 9;
+		if (value) {
+			set_bit(bitnum, &gpio_regs[0]);
+		} else {
+			clear_bit(bitnum, &gpio_regs[0]);
+		}
+	}
+}
+
+#else
+
+static void gpio_bit_set(unsigned int value) { }
+static void gpio_init(void) { }
+static void gpio_cleanup(void) { }
+
+#endif
+
+/******************************************************************************
+* board configuration                                                         *
+******************************************************************************/
+
+#define ASICS_NUM_INTERFACES	1
+
+struct i2c_asics_interface_configuration {
+    int used;
+    int base_offset;
+    int irq;
+    int irq_mux;
+    int scl;
+    int clock;
+    uint8_t slave_address; /* currently only 7 bit slave address supported */
+};
+
+#warning i2c ctrl hardcoded to FPGA - I2C2 (SMB_ICH on MSI-card)
+static struct i2c_asics_interface_configuration i2c_asics_interfaces[ASICS_NUM_INTERFACES] = {
+//    { 1, I2C_0_BASE_OFFSET, ASICS_I2C_IRQ, I2C_0_INTMUX, 100, 0, 0x33 },
+//    { 1, I2C_1_BASE_OFFSET, ASICS_I2C_IRQ, I2C_1_INTMUX, 100, 0, 0x33 },
+//    { 1, I2C_2_BASE_OFFSET, ASICS_I2C_IRQ, I2C_2_INTMUX, 100, 0, 0x33 },
+//    { 1, I2C_3_BASE_OFFSET, ASICS_I2C_IRQ, I2C_3_INTMUX, 100, 0, 0x33 },
+//    { 1, I2C_4_BASE_OFFSET, ASICS_I2C_IRQ, I2C_4_INTMUX, 100, 0, 0x33 },
+    { 1, I2C_DDC_BASE_OFFSET, ASICS_I2C_IRQ, I2C_DDC_INTMUX, 100, 33, 0x33 },
+//    { 1, I2C_LAN_BASE_OFFSET, ASICS_I2C_IRQ, I2C_LAN_INTMUX, 100, 0, 0x33 },
+};
+
+/*
+static struct i2c_asics_interface_configuration i2c_asics_interfaces[ASICS_NUM_INTERFACES] = {
+    { 1, ASICS_BASE + I2C_DDC_BASE_OFFSET, ASICS_I2C_IRQ, I2C_DDC_INTMUX, 100, 0, 0x33 },
+};
+*/
+
+/******************************************************************************
+* function prototypes                                                         *
+******************************************************************************/
+
+static int asicsi2c_wait_for_tdone(struct iic_asics_hw *hw);
+static irqreturn_t asics_handler(int this_irq, void *dev_id, struct pt_regs *regs);
+static int asics_hw_init(struct iic_asics_hw *hw);
+static void asics_slave_init(struct i2c_algo_asics_slave_data * slave_data);
+static int asics_slave_init_adapter(struct i2c_slave_adapter *slave, struct i2c_adapter *adap);
+static int i2c_asics_adapter_init(struct i2c_adapter *i2c_adap, unsigned int slave_address);
+static void asics_hw_exit(struct iic_asics_hw* hw);
+static int asics_slave_cleanup_adapter(struct i2c_slave_adapter *slave);
+static void i2c_asics_adapter_cleanup(struct i2c_adapter *i2c_adap);
+static struct i2c_adapter* i2c_asics_get_adapter_from_hw(struct iic_asics_hw *hw);
+
+/******************************************************************************
+* helper functions                                                            *
+******************************************************************************/
+
+static char* num_to_bin(uint8_t num)
+{
+	static char bin[9];
+	int i;
+	
+	for (i = 0; i < 8; i++) {
+		bin[i] = (num & (1 << (7 - i))) ? '1' : '0';
+	}
+	bin[8] = '\0';
+	
+	return bin;
+}
+
+static void asicsi2c_setreg(struct iic_asics_hw *hw, int regno, int val)
+{
+	DBG3("asicsi2c_setreg: regno %02x (%s), value 0x%02x (%s)\n",
+		regno,
+		regno == 0 ? "PRERL" : regno == 1 ? "PRERH" : regno == 2 ? "CCR" :
+			regno == 3 ? "SR" : regno == 4 ? "DR" : regno == 5 ? "SAR" :
+			regno == 6 ? "ESAR" : "unknown",
+		val, num_to_bin(val));
+	writeb(val, &hw->asics_regs[regno]);
+}
+
+static int asicsi2c_getreg_nodbg(struct iic_asics_hw *hw, int regno)
+{
+	return readb(&hw->asics_regs[regno]);
+}
+
+#if DBG_LEVEL > 2
+static int asicsi2c_getreg(struct iic_asics_hw *hw, int regno)
+{
+	int ret = asicsi2c_getreg_nodbg(hw, regno);
+	
+	DBG3("asicsi2c_getreg: regno %02x (%s), value 0x%02x (%s)\n",
+		regno,
+		regno == 0 ? "PRERL" : regno == 1 ? "PRERH" : regno == 2 ? "CCR" :
+			regno == 3 ? "SR" : regno == 4 ? "DR" : regno == 5 ? "SAR" :
+			regno == 6 ? "ESAR" : "unknown",
+		ret, num_to_bin(ret));
+	
+	return ret;
+}
+#else /* DBG_LEVEL > 2 */
+//#define asicsi2c_setreg asicsi2c_setreg_nodbg
+#define asicsi2c_getreg asicsi2c_getreg_nodbg
+#endif /* DBG_LEVEL > 2 */
+
+#define asics_set_bit(hw, register, bit) \
+	asicsi2c_setreg(hw, register, asicsi2c_getreg_nodbg(hw, register) | bit)
+#define asics_clear_bit(hw, register, bit) \
+	asicsi2c_setreg(hw, register, asicsi2c_getreg_nodbg(hw, register) & ~bit)
+
+
+static int asicsi2c_wait_for_tdone(struct iic_asics_hw *hw)
+{
+	int timeout = 2;
+
+	if (hw->irq > 0) {
+		DBG("Waiting for transfer to end (interrupt)...\n");
+		wait_event_interruptible_timeout(hw->wait, 
+					((asicsi2c_getreg(hw, REG_ASICSI2C_SR) & BIT_ASICSI2C_SR_TDONE) != 0) || hw->arbitration_lost, 
+					timeout*HZ);
+		DBG("...Waiting finished.\n");
+	} else {
+		DBG("Waiting for transfer to end (polling).\n");
+		udelay(100);
+	}
+	
+	if (!(asicsi2c_getreg(hw, REG_ASICSI2C_SR) & BIT_ASICSI2C_SR_TDONE) && !hw->arbitration_lost)
+		return -1;
+	return 0;
+}
+
+/******************************************************************************
+* interrupt handler                                                           *
+******************************************************************************/
+
+static irqreturn_t asics_handler(int this_irq, void *dev_id, struct pt_regs *regs) 
+{
+	struct iic_asics_hw *hw= (struct iic_asics_hw *)dev_id;
+	struct i2c_adapter *i2c_adap = i2c_asics_get_adapter_from_hw(hw);
+	struct i2c_algo_asics_data *adap = (struct i2c_algo_asics_data *) i2c_adap->algo_data;
+
+	uint8_t cr = asicsi2c_getreg_nodbg(hw, REG_ASICSI2C_CCR);
+	uint8_t sr = asicsi2c_getreg_nodbg(hw, REG_ASICSI2C_SR);
+	
+	int arbitration_lost = 0;
+	
+	gpio_bit_set(1);
+
+	DBG2("---- asics_handler start\n");
+
+	SDBG("\n+\n");
+#ifdef ASICS_USE_INTMUX
+	if (hw->irq_mux != ASICSI2C_IRQ_NO_INTMUX) {
+	    u_long mux = readl(&hw->intmux_reg[0]);
+	    if (!test_bit(hw->irq_mux, &mux)) {
+		// this is not our IRQ
+		DBG2("---- asics_handler: not our irq\n");
+		SDBG("-\n");
+		gpio_bit_set(0);
+		return;
+	    }
+	}
+#endif
+	
+	DBG2("---- asics_handler our irq\n");
+
+	DBG2("asics_handler: CCR=0x%02x (%s)\n", cr, num_to_bin(cr));
+	DBG2("asics_handler: SR=0x%02x (%s)\n", sr, num_to_bin(sr));
+	DBG2("asics_handler: DR=0x%02x (%s)\n", asicsi2c_getreg_nodbg(hw, REG_ASICSI2C_DR), num_to_bin(asicsi2c_getreg_nodbg(hw, REG_ASICSI2C_DR)));
+	SDBG("%x %x\n", cr, sr);
+	DBG3("asics_handler: SAR=0x%02x (%s)\n", asicsi2c_getreg_nodbg(hw, REG_ASICSI2C_SAR), num_to_bin(asicsi2c_getreg_nodbg(hw, REG_ASICSI2C_SAR)));
+	DBG3("asics_handler: ESAR=0x%02x (%s)\n", asicsi2c_getreg_nodbg(hw, REG_ASICSI2C_ESAR), num_to_bin(asicsi2c_getreg_nodbg(hw, REG_ASICSI2C_ESAR)));
+	DBG3("asics_handler: PRERL=0x%02x (%s)\n", asicsi2c_getreg_nodbg(hw, REG_ASICSI2C_PRERL), num_to_bin(asicsi2c_getreg_nodbg(hw, REG_ASICSI2C_PRERL)));
+	DBG3("asics_handler: PRERH=0x%02x (%s)\n", asicsi2c_getreg_nodbg(hw, REG_ASICSI2C_PRERH), num_to_bin(asicsi2c_getreg_nodbg(hw, REG_ASICSI2C_PRERH)));
+	
+	/* check for arbitration lost */
+	if (sr & BIT_ASICSI2C_SR_AL) {
+		DBG2("lost arbitration\n");
+		arbitration_lost = hw->arbitration_lost = 1;
+		adap->current_state = I2C_ASICS_MODE_IDLE;
+		asics_clear_bit(hw, REG_ASICSI2C_SR, BIT_ASICSI2C_SR_AL);
+	} else {
+		arbitration_lost = hw->arbitration_lost = 0;
+	}
+	
+	/* check for slave mode */
+	if (sr & BIT_ASICSI2C_SR_CAS) {
+	    DBG2("switching to slave mode\n");
+	    if (adap->current_state != I2C_ASICS_MODE_SLAVE) {
+		    /* clear old stop condition, if any */
+		    if (sr & BIT_ASICSI2C_SR_DSP) {
+			DBG2("clear unknown stop cond\n");
+			adap->current_state = I2C_ASICS_MODE_IDLE;
+			asics_clear_bit(hw, REG_ASICSI2C_SR, BIT_ASICSI2C_SR_DSP);
+			sr &= ~BIT_ASICSI2C_SR_DSP;
+		    }
+	    }
+	    adap->current_state = I2C_ASICS_MODE_SLAVE;
+	}
+
+	if (!(cr & BIT_ASICSI2C_CC_MS) && !arbitration_lost) {
+		DBG3("got slave request, found adapter %s.\n", i2c_adap->name);
+		cr = i2c_asics_handle_slave_request(i2c_adap);
+		SDBG("%x\n", cr);
+		asicsi2c_setreg(hw, REG_ASICSI2C_CCR, cr);
+	}
+	
+	/* check for stop condition */
+	if (sr & BIT_ASICSI2C_SR_DSP) {
+		DBG2("switching to idle mode\n");
+		adap->current_state = I2C_ASICS_MODE_IDLE;
+		asics_clear_bit(hw, REG_ASICSI2C_SR, BIT_ASICSI2C_SR_DSP);
+	}
+	
+	/* ack this interrupt */
+	asics_clear_bit(hw, REG_ASICSI2C_SR, BIT_ASICSI2C_SR_IF);
+
+	wake_up_interruptible(&hw->wait);
+	
+	DBG2("---- asics_handler finished\n");
+	SDBG("-\n");
+	gpio_bit_set(0);
+
+	return IRQ_HANDLED;
+}
+
+
+/******************************************************************************
+* initialization functions                                                    *
+******************************************************************************/
+
+static int asics_hw_init(struct iic_asics_hw *hw)
+{
+	int prescale;
+	int dev_base;
+#ifdef ASICS_USE_PCI
+	struct pci_dev *pci_dev;
+#endif
+	
+#ifdef ASICS_USE_PCI
+	pci_dev = pci_find_device(ASICS_PCI_VENDOR_ID, ASICS_PCI_DEVICE_ID, NULL);
+	if (pci_dev == NULL) {
+	    ERR("PCI device not detected\n");
+	    return -ENODEV;
+	}
+	dev_base = pci_resource_start(pci_dev, ASICS_PCI_BAR_NO);
+#else
+	dev_base = ASICS_BASE;
+#endif
+	hw->base = dev_base + hw->base_offset;
+	DBG("using physical base address 0x%08x\n", hw->base);
+	
+#ifdef ASICS_USE_INTMUX
+	hw->intmux_reg = ioremap_nocache(dev_base + INTMUX_OFFSET, INTMUX_SIZE);
+	if (hw->intmux_reg == NULL) {
+	    ERR("failed to map IRQ multiplexer\n");
+	    return -ENODEV;
+	}
+	DBG("mapped IRQ multiplexer from 0x%08x to 0x%p (%d Byte)\n", dev_base + INTMUX_OFFSET,
+	    hw->intmux_reg, INTMUX_SIZE);
+#endif
+	
+	if (!request_mem_region(hw->base, ASICSI2C_IO_SIZE, "i2c (bus adapter)")) {
+		ERR("requested MMIO region (0x%X:2) is in use.\n", hw->base);
+		return -ENODEV;
+	}
+
+	/* map asics regs */
+	hw->asics_regs = ioremap_nocache(hw->base, ASICSI2C_IO_SIZE);
+	if (hw->asics_regs == NULL) {
+	    ERR("failed to map ASICS regs\n");
+	    return -ENOMEM;
+	}
+	DBG("mapped ASICS regs from 0x%08x to 0x%p (%d Byte)\n", hw->base,
+	    hw->asics_regs, ASICSI2C_IO_SIZE);
+	
+	/* clear EN and MS bit */
+	asicsi2c_setreg(hw, REG_ASICSI2C_CCR, 0);
+	
+	/* compute prescale */
+	prescale = hw->clock * 1000 / (4 * hw->scl) - 1;
+	DBG("scl=%d, clock=%d -> prescale=%d\n", hw->scl, hw->clock, prescale);
+	if (prescale < 0) {
+	    ERR("prescale error clk_i %d scl %d\n", hw->clock, hw->scl);
+	    return -ENODEV;
+	}
+	
+	/* set prescale */
+	asicsi2c_setreg(hw, REG_ASICSI2C_PRERL, prescale & 0xff);
+	asicsi2c_setreg(hw, REG_ASICSI2C_PRERH, prescale >> 8);
+	
+	/* error debugging */
+	asicsi2c_setreg(hw, REG_ASICSI2C_SR, 8);
+	asicsi2c_setreg(hw, REG_ASICSI2C_DR, 0x20);
+
+	if (hw->irq > 0) {
+		if (request_irq(hw->irq, asics_handler, SA_SHIRQ | SA_SAMPLE_RANDOM, "Asics I2C", hw) < 0) {
+			ERR("Request irq%d failed\n", hw->irq);
+			hw->irq = 0;
+
+			/* set EN bit */
+			asicsi2c_setreg(hw, REG_ASICSI2C_CCR, BIT_ASICSI2C_CC_ENA);
+		} else {
+			DBG("Requested irq %d.\n", hw->irq);
+
+			/* set EN bit */
+			asicsi2c_setreg(hw, REG_ASICSI2C_CCR, BIT_ASICSI2C_CC_ENA | BIT_ASICSI2C_CC_IEN);
+		}
+	}
+	
+	hw->arbitration_lost = 0;
+
+	DBG2("asics_hw_init successful\n");
+	return 0;
+}
+
+static void asics_slave_init(struct i2c_algo_asics_slave_data * slave_data)
+{
+	spin_lock_init(slave_data->slave_lock);
+	
+	slave_data->block_next_slave_operation = 0;
+	slave_data->last_slave_op = I2C_ASICS_SLAVE_OP_NONE;
+	
+        slave_data->slave_write_ptr = slave_data->slave_write_buffer;
+        slave_data->slave_write_count = 0;
+        slave_data->slave_read_ptr = slave_data->slave_read_buffer;
+        slave_data->slave_read_count = 0;
+}
+
+/* register adapter in slave layer */
+static int asics_slave_init_adapter(struct i2c_slave_adapter *slave, struct i2c_adapter *adap)
+{
+	int ret = 0;
+
+	slave->adapter = adap;
+	slave->reactivate = i2c_asics_slave_restart_xfer;
+	if ((ret = i2c_slave_add_adapter(slave)) != 0){
+		CRIT("failed to register i2c slave adapter\n");
+		return ret;
+	}
+	
+	return 0;
+}
+
+static int i2c_asics_adapter_init(struct i2c_adapter *i2c_adap, unsigned int slave_address)
+{
+	struct i2c_algo_asics_data *adap = (struct i2c_algo_asics_data *) i2c_adap->algo_data;
+	struct iic_asics_hw *hw = adap->hw;
+	struct i2c_algo_asics_slave_data *slave_data = adap->slave_data;
+	struct i2c_slave_adapter *slave_adapter = adap->slave_adapter;
+	
+	DBG3("Initializing hardware for %s.\n", i2c_adap->name);
+	
+	init_waitqueue_head(&hw->wait);
+	if (asics_hw_init(hw) == 0) {
+		if (i2c_asics_add_bus(i2c_adap) < 0) {
+			asics_hw_exit(hw);
+			return -1;
+		}
+		if (asics_slave_init_adapter(slave_adapter, i2c_adap) < 0) {
+			asics_hw_exit(hw);
+			return -1;
+		}
+	}
+	
+	asics_slave_init(slave_data);
+	i2c_asics_slave_set_address(i2c_adap, slave_address);
+	
+	return 0;
+}
+
+/******************************************************************************
+* cleanup functions                                                           *
+******************************************************************************/
+
+static void asics_hw_exit(struct iic_asics_hw* hw)
+{
+	/* free irq */
+	if (hw->irq > 0) {
+		free_irq(hw->irq, hw);
+	}
+
+	/* free register mapping */
+	if (hw->asics_regs != NULL) {
+	    iounmap((void*)hw->asics_regs);
+	    hw->asics_regs = NULL;
+	}
+	
+	/* free mem region */
+	release_mem_region(hw->base, ASICSI2C_IO_SIZE);
+	
+#ifdef ASICS_USE_INTMUX
+    if (hw->intmux_reg != NULL) {
+	iounmap((void *)hw->intmux_reg);
+	hw->intmux_reg = NULL;
+    }    
+#endif
+}
+
+/* deregister */
+static int asics_slave_cleanup_adapter(struct i2c_slave_adapter *slave)
+{
+	int ret;
+	
+	if ((ret = i2c_slave_remove_adapter(slave)) != 0) {
+		CRIT("failed to deregister i2c slave adapter\n");
+		return ret;
+	}
+	
+	return 0;
+}
+
+static void i2c_asics_adapter_cleanup(struct i2c_adapter *i2c_adap)
+{
+	struct i2c_algo_asics_data *data = (struct i2c_algo_asics_data *) i2c_adap->algo_data;
+	struct iic_asics_hw *hw = data->hw;
+	struct i2c_slave_adapter *slave_adapter = data->slave_adapter;
+
+	i2c_asics_del_bus(i2c_adap);
+	asics_hw_exit(hw);
+	asics_slave_cleanup_adapter(slave_adapter);
+}
+
+/******************************************************************************
+* module data                                                                 *
+******************************************************************************/
+
+/* there are several adapters on the board */
+
+static char* asics_names[ASICS_NUM_INTERFACES] = {
+	"Asics i2c 0",
+};
+
+static struct i2c_algo_asics_slave_data asics_slave[ASICS_NUM_INTERFACES];
+
+static struct i2c_slave_adapter asics_slave_adapt[ASICS_NUM_INTERFACES];
+
+static struct iic_asics_hw asics_hw[ASICS_NUM_INTERFACES];
+
+static struct i2c_algo_asics_data asics_data[ASICS_NUM_INTERFACES];
+
+static struct i2c_adapter asics_ops[ASICS_NUM_INTERFACES];
+
+
+static struct i2c_adapter* i2c_asics_get_adapter_from_hw(struct iic_asics_hw *hw)
+{
+	int i;
+	
+	for (i = 0; i < ASICS_NUM_INTERFACES; i++) {
+		if (hw == ((struct i2c_algo_asics_data *) asics_ops[i].algo_data)->hw) return &asics_ops[i];
+	}
+	
+	return NULL;
+}
+
+static void i2c_asics_init_adapters(void) {
+	int i;
+	
+	memset(asics_ops, 0, sizeof(asics_ops));
+	memset(asics_data, 0, sizeof(asics_data));
+	memset(asics_hw, 0, sizeof(asics_hw));
+	memset(asics_slave_adapt, 0, sizeof(asics_slave_adapt));
+	memset(asics_slave, 0, sizeof(asics_slave));
+
+	for (i = 0; i < ASICS_NUM_INTERFACES; i++) {
+		if (!i2c_asics_interfaces[i].used) {
+			continue;
+		}
+		
+		/* fill i2c_adapter struct */
+#warning owner n/a for 2.4
+		//asics_ops[i].owner		= THIS_MODULE;
+		asics_ops[i].id			= I2C_HW_ASICS_UKIT;
+		asics_ops[i].algo_data		= &asics_data[i];
+		strncpy(asics_ops[i].name, asics_names[i], sizeof(asics_ops[i].name));
+		
+		/* fill i2c_algo_asics_data struct */
+		asics_data[i].hw		= &asics_hw[i];
+		asics_data[i].slave_data	= &asics_slave[i];
+		asics_data[i].slave_adapter	= &asics_slave_adapt[i];
+		asics_data[i].setreg		= asicsi2c_setreg;
+		asics_data[i].getreg		= asicsi2c_getreg;
+		asics_data[i].wait_for_tdone	= asicsi2c_wait_for_tdone;
+		asics_data[i].udelay		= 10,
+		asics_data[i].mdelay		= 10,
+		asics_data[i].timeout		= 100,
+		asics_data[i].current_state	= I2C_ASICS_MODE_IDLE,
+		
+		/* fill iic_asics_hw struct */
+		asics_hw[i].base_offset		= i2c_asics_interfaces[i].base_offset ? i2c_asics_interfaces[i].base_offset : 0;
+		asics_hw[i].irq			= i2c_asics_interfaces[i].irq ? i2c_asics_interfaces[i].irq : 0;
+		asics_hw[i].irq_mux		= i2c_asics_interfaces[i].irq_mux ? i2c_asics_interfaces[i].irq_mux : 0;
+		asics_hw[i].clock		= i2c_asics_interfaces[i].clock ? i2c_asics_interfaces[i].clock : ASICSI2C_CLOCK_DEFAULT;
+		asics_hw[i].scl			= i2c_asics_interfaces[i].scl ? i2c_asics_interfaces[i].scl : ASICSI2C_SCL_DEFAULT;
+	}
+}
+
+/******************************************************************************
+* module stuff                                                                *
+******************************************************************************/
+
+static int __init i2c_asics_init(void) 
+{
+	int i;
+	
+	INFO("i2c Asics adapter driver\n");
+
+	gpio_init();
+	mdelay(500);
+
+	/* parameters */
+	i2c_asics_init_adapters();
+	
+	for (i = 0; i < ASICS_NUM_INTERFACES; i++) {
+		i2c_asics_adapter_init(&asics_ops[i], i2c_asics_interfaces[i].slave_address);
+	}
+	
+#if DBG_SEND_MESSAGES_ON_LOAD
+	send_some_messages(&asics_ops[0]);
+#endif
+	return 0;
+}
+
+static void i2c_asics_exit(void)
+{
+	int i;
+
+	for (i = 0; i < ASICS_NUM_INTERFACES; i++) {
+		i2c_asics_adapter_cleanup(&asics_ops[i]);
+	}
+	
+	gpio_cleanup();
+}
+
+module_init(i2c_asics_init);
+module_exit(i2c_asics_exit);
Index: pplinux/linuxnew/drivers/i2c/i2c-asics.h
diff -u /dev/null pplinux/linuxnew/drivers/i2c/i2c-asics.h:1.1
--- /dev/null	Tue May 24 10:37:58 2005
+++ pplinux/linuxnew/drivers/i2c/i2c-asics.h	Tue Feb 15 12:19:53 2005
@@ -0,0 +1,49 @@
+/*   Copyright (C) 2004 Microtronix Datacom Ltd
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		*/
+
+#ifndef I2C_ASICS_H
+#define I2C_ASICS_H 1
+
+/* Register map */
+#define REG_ASICSI2C_PRERL		0	/* prescale low register */
+#define REG_ASICSI2C_PRERH		1	/* prescale high register */
+#define REG_ASICSI2C_CCR		2	/* control/command register */
+#define REG_ASICSI2C_SR			3	/* status register */
+#define REG_ASICSI2C_DR			4	/* data register */
+#define REG_ASICSI2C_SAR		5	/* slave address register */
+#define REG_ASICSI2C_ESAR		6	/* extended address register */
+
+/* control/command register */
+#define BIT_ASICSI2C_CC_ENA		(1<<7)	/* core enabled */
+#define BIT_ASICSI2C_CC_IEN		(1<<6)	/* interrupt enabled */
+#define BIT_ASICSI2C_CC_MS		(1<<5)	/* master/slave select */
+#define BIT_ASICSI2C_CC_RSTA		(1<<4)	/* repeated start condition */
+#define BIT_ASICSI2C_CC_RD		(1<<3)	/* read */
+#define BIT_ASICSI2C_CC_WR		(1<<2)	/* write */
+#define BIT_ASICSI2C_CC_T_NO_ACK	(1<<1)	/* transmit acknowledge */
+
+/* status register */
+#define BIT_ASICSI2C_SR_TDONE		(1<<7)	/* transfer done */
+#define BIT_ASICSI2C_SR_BSY		(1<<6)	/* bus busy */
+#define BIT_ASICSI2C_SR_AL		(1<<5)	/* arbitration lost */
+#define BIT_ASICSI2C_SR_CAS		(1<<4)	/* called as slave */
+#define BIT_ASICSI2C_SR_DSP		(1<<3)	/* detected stop condition */
+#define BIT_ASICSI2C_SR_SRW		(1<<2)	/* slave read/write */
+#define BIT_ASICSI2C_SR_R_NO_ACK	(1<<1)	/* received ack */
+#define BIT_ASICSI2C_SR_IF		1	/* interrupt flag */
+
+
+#endif /* I2C_ASICS_H */
Index: pplinux/linuxnew/drivers/i2c/i2c-core.c
diff -u pplinux/linuxnew/drivers/i2c/i2c-core.c:1.1.323.1 pplinux/linuxnew/drivers/i2c/i2c-core.c:1.4
--- pplinux/linuxnew/drivers/i2c/i2c-core.c:1.1.323.1	Thu Feb  3 10:00:38 2005
+++ pplinux/linuxnew/drivers/i2c/i2c-core.c	Tue Feb 15 12:19:53 2005
@@ -390,12 +390,12 @@
 	return 0;
 }
 
-int i2c_attach_client(struct i2c_client *client)
+int i2c_attach_client_internal(struct i2c_client *client, int force)
 {
 	struct i2c_adapter *adapter = client->adapter;
 	int i;
 
-	if (i2c_check_addr(client->adapter,client->addr))
+	if (!force && i2c_check_addr(client->adapter,client->addr))
 		return -EBUSY;
 
 	for (i = 0; i < I2C_CLIENT_MAX; i++)
@@ -425,6 +425,16 @@
 	return 0;
 }
 
+int i2c_attach_client(struct i2c_client *client)
+{
+	return i2c_attach_client_internal(client, 0);
+}
+
+int i2c_attach_client_force(struct i2c_client *client)
+{
+	return i2c_attach_client_internal(client, 1);
+}
+
 
 int i2c_detach_client(struct i2c_client *client)
 {
@@ -803,6 +813,53 @@
 	}
 }
 
+int i2c_slave_send(struct i2c_client *client, char* buf, int count)
+{
+	struct i2c_adapter *adap=client->adapter;
+	int ret = 0;
+
+	if (client->adapter->algo->slave_send) {
+               
+		DEB2(printk("i2c-core.o: slave_send: trying to send %d bytes on %s.\n",
+			    count,client->adapter->name));
+
+		I2C_LOCK(adap);
+		ret = adap->algo->slave_send(adap, buf, count);
+		I2C_UNLOCK(adap);
+
+		return (ret == 0)? count : ret;    
+	} else {
+		printk("i2c-core.o: I2C adapter %04x: I2C slave send not supported\n",
+		       client->adapter->id);
+		return -ENOSYS;
+	}
+
+}
+
+int i2c_slave_recv(struct i2c_client *client, char* buf, int count)
+{
+	struct i2c_adapter *adap=client->adapter;
+	int ret = 0;
+
+	if (client->adapter->algo->slave_recv) {
+
+		DEB2(printk("i2c-core.o: slave_recv: trying to receive %d bytes on %s.\n",
+			    count,client->adapter->name));
+
+		I2C_LOCK(adap);
+		ret = adap->algo->slave_recv(adap, buf, count);
+		I2C_UNLOCK(adap);
+
+		DEB2(printk("i2c-core.o: slave_recv: return:%d (count:%d, addr:0x%02x)\n",
+			    ret, count, client->addr));
+
+		return ret;
+	} else {
+		printk("i2c-core.o: I2C adapter %04x: I2C slave receive not supported\n",
+		       client->adapter->id);
+		return -ENOSYS;
+	}
+}
 
 int i2c_control(struct i2c_client *client,
 	unsigned int cmd, unsigned long arg)
@@ -830,9 +887,10 @@
  * Will not work for 10-bit addresses!
  * ----------------------------------------------------
  */
-int i2c_probe(struct i2c_adapter *adapter,
+int i2c_probe_internal(struct i2c_adapter *adapter,
                    struct i2c_client_address_data *address_data,
-                   i2c_client_found_addr_proc *found_proc)
+                   i2c_client_found_addr_proc *found_proc,
+                   int force)
 {
 	int addr,i,found,err;
 	int adap_id = i2c_adapter_id(adapter);
@@ -844,7 +902,7 @@
 	for (addr = 0x00; addr <= 0x7f; addr++) {
 
 		/* Skip if already in use */
-		if (i2c_check_addr(adapter,addr))
+		if (!force && i2c_check_addr(adapter,addr))
 			continue;
 
 		/* If it is in one of the force entries, we don't do any detection
@@ -951,6 +1009,20 @@
 	return 0;
 }
 
+int i2c_probe(struct i2c_adapter *adapter,
+                   struct i2c_client_address_data *address_data,
+                   i2c_client_found_addr_proc *found_proc)
+{
+	return i2c_probe_internal(adapter, address_data, found_proc, 0);
+}
+
+int i2c_probe_force(struct i2c_adapter *adapter,
+                   struct i2c_client_address_data *address_data,
+                   i2c_client_found_addr_proc *found_proc)
+{
+	return i2c_probe_internal(adapter, address_data, found_proc, 1);
+}
+
 /*
  * return id number for a specific adapter
  */
@@ -1350,6 +1422,7 @@
 EXPORT_SYMBOL(i2c_add_driver);
 EXPORT_SYMBOL(i2c_del_driver);
 EXPORT_SYMBOL(i2c_attach_client);
+EXPORT_SYMBOL(i2c_attach_client_force);
 EXPORT_SYMBOL(i2c_detach_client);
 EXPORT_SYMBOL(i2c_inc_use_client);
 EXPORT_SYMBOL(i2c_dec_use_client);
@@ -1365,6 +1438,10 @@
 EXPORT_SYMBOL(i2c_transfer);
 EXPORT_SYMBOL(i2c_adapter_id);
 EXPORT_SYMBOL(i2c_probe);
+EXPORT_SYMBOL(i2c_probe_force);
+
+EXPORT_SYMBOL(i2c_slave_recv);
+EXPORT_SYMBOL(i2c_slave_send);
 
 EXPORT_SYMBOL(i2c_smbus_xfer);
 EXPORT_SYMBOL(i2c_smbus_write_quick);
Index: pplinux/linuxnew/drivers/i2c/i2c-dev.c
diff -u pplinux/linuxnew/drivers/i2c/i2c-dev.c:1.1.323.1 pplinux/linuxnew/drivers/i2c/i2c-dev.c:1.3
--- pplinux/linuxnew/drivers/i2c/i2c-dev.c:1.1.323.1	Thu Feb  3 10:00:38 2005
+++ pplinux/linuxnew/drivers/i2c/i2c-dev.c	Tue Feb 15 12:19:53 2005
@@ -42,7 +42,7 @@
 
 
 /* If you want debugging uncomment: */
-/* #define DEBUG */
+#define DEBUG
 
 #include <linux/init.h>
 #include <asm/uaccess.h>
@@ -146,7 +146,11 @@
 	       count);
 #endif
 
-	ret = i2c_master_recv(client,tmp,count);
+	if (client->flags & I2C_CLIENT_RECV_SLAVE) {
+		ret = i2c_slave_recv(client,tmp,count);
+	} else {
+		ret = i2c_master_recv(client,tmp,count);
+	}
 	if (ret >= 0)
 		ret = copy_to_user(buf,tmp,count)?-EFAULT:ret;
 	kfree(tmp);
@@ -379,6 +383,14 @@
 		}
 		return res;
 
+	case I2C_SLAVE_MODE_ENABLE:
+		client->flags |= I2C_CLIENT_RECV_SLAVE;
+		break;
+
+	case I2C_SLAVE_MODE_DISABLE:
+		client->flags &= ~I2C_CLIENT_RECV_SLAVE;
+		break;
+
 	default:
 		return i2c_control(client,cmd,arg);
 	}
